<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title> sch-rnd user manual </title>
<meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
<link rel="stylesheet" type="text/css" href=" ../default.css">
</head>
<body>
<p>
<h1> sch-rnd User Manual: Appendix </h1>
<p>
<h2> Action Reference</h2>
<table border=1>
<caption>
 <b>
, 
</b>
<th> Action <th> Description <th> Syntax <th> Plugin
<tr><td>About</td><td>Present the about box</td><td>About()</td><td>sch_dialogs</td>
<tr><td>AbstractDialog</td><td>Bring up the current project's abstract model dialog. If abstract object id, abst_id is specified, left-side cursor is set at that object initially. If attr_name is specified, right-side cursor is set on that attribute.</td><td>AbstractDialog([abst_id [,attr_name]])</td><td>sch_dialogs</td>
<tr><td>ActionString</td><td>Execute a pcb-rnd action parsing a string; syntac: "action(arg,arg,arg)"</td><td>ActionString(action)</td><td>script plugin</td>
<tr><td><a href="action_details.html#addtimer">AddTimer</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Add a new timer</td><td>AddTimer(action, period, [repeat], [userdata])</td><td>script plugin</td>
<tr><td><a href="action_details.html#anyload">AnyLoad</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Load "anything" from path (or offer a file selectio dialog if no path specified)</td><td>AnyLoad([path])</td><td></td>
<tr><td>AttributeDialog</td><td>Bring up the Attribute Editor Dialog for an object.</td><td>AttributeDialog([last-click|parent|sheet|object[:idpath]], [target_key])</td><td>sch_dialogs</td>
<tr><td>AttributePick</td><td>Bring up the Attribute Pick Dialog and ask the user to pick an attribute of an object.</td><td>AttributePick([last-click|parent|object[:idpath]], [target_key])</td><td>sch_dialogs</td>
<tr><td>awk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>Backann</td><td>Load a back annotation file for interactive back annotation</td><td>Backann([filename])</td><td>backann plugin</td>
<tr><td>bas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td><a href="action_details.html#benchmark">Benchmark</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Benchmark the GUI speed.</td><td>Benchmark()</td><td></td>
<tr><td>Breakup</td><td>Breakup group(s) found in context named in first arg, place resulting objects in the context named in second arg if present or on sheet if not present</td><td>Breakup(selected|buffer|object, group|poly[gon]|all, [sheet|grp-oid])</td><td>construct plugin</td>
<tr><td>BrowseScripts</td><td>Present a dialog box for browsing scripts</td><td>BrowseScripts()</td><td>script plugin</td>
<tr><td>BufferChk</td><td>Returns whether buffer num is active or not</td><td>BufferChk(num)</td><td></td>
<tr><td>BufferClear</td><td>Empty currently active paste buffer.</td><td>BufferClear()</td><td></td>
<tr><td>BufferCopy</td><td>Copy selection to currently active paste buffer.</td><td>BufferCopy([x, y])</td><td></td>
<tr><td>BufferCut</td><td>Cut selection to currently active paste buffer: copy objects then remove them from the sheet.</td><td>BufferCut()</td><td></td>
<tr><td>BufferLoad</td><td>Load content of buffer from file</td><td>BufferLoad([group|symbol|all, [filename], [fmt])</td><td></td>
<tr><td>BufferPaste</td><td>Paste selection from active paste buffer to the board at crosshair or x;y.</td><td>BufferPaste([x, y])</td><td></td>
<tr><td>BufferSave</td><td>Save content of buffer; if first arg is symbol, the first symbol group is saved, if sheet the whole buffer is saved as sheet</td><td>BufferSave([group|symbol|all, [filename], [fmt])</td><td></td>
<tr><td>BufferSwitch</td><td>Activates buffer num</td><td>BufferSwitch(num)</td><td></td>
<tr><td><a href="action_details.html#center">Center</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Moves the pointer to the center of the window.</td><td>Center()</td><td>lib_hid_common plugin</td>
<tr><td>ChkGridSize</td><td>Return 1 if the currently selected grid matches the expected_size. If argument is "none" return 1 if there is no grid.</td><td>ChkGridSize(expected_size)<br>ChkGridSize(none)</td><td></td>
<tr><td>ChkGridUnits</td><td>Return 1 if currently selected grid unit matches the expected (normally mm or mil)</td><td>ChkGridUnits(expected)</td><td></td>
<tr><td>ChkMode</td><td>Return 1 if the currently selected mode is the expected_mode</td><td>ChkMode(expected_mode)</td><td></td>
<tr><td>cli_MessageBox</td><td>Intenal: CLI frontend action. Do not use directly.</td><td></td><td></td>
<tr><td>cli_PromptFor</td><td>Intenal: CLI frontend action. Do not use directly.</td><td></td><td></td>
<tr><td>Command</td><td>Displays the command line input in the status area.</td><td>Command()</td><td>lib_hid_common plugin</td>
<tr><td>CompileProject</td><td>Compile the abstract model of the current project, using the current view (or the view named)</td><td>CompileProject([view_name])</td><td>project_act</td>
<tr><td>ConditionalDialog</td><td>Open the conditional helper dialog for an object.</td><td>ConditionalDialog(object, dnp|omit)</td><td>sch_dialogs</td>
<tr><td>conf</td><td>Perform various operations on the configuration tree.</td><td>conf(set, path, value, [role], [policy]) - change a config setting to an absolute value<br>conf(delta, path, value, [role], [policy]) - change a config setting by a delta value (numerics-only)<br>conf(toggle, path, [role]) - invert boolean value of a flag; if no role given, overwrite the highest prio config<br>conf(reset, role) - reset the in-memory lihata of a role<br>conf(iseq, path, value) - returns whether the value of a conf item matches value (for menu checked's)</td><td></td>
<tr><td>confget</td><td>Return conf node value or property from the merged in-memory/native storage. Returns nil if node is unset (for value query) or not found. Intended for scripting.</td><td>ConfGet(path, [value]) - return the value of a conf node; units, colors and lists are returned as string.<br>ConfGet(path, desc) - return the human readable description<br>ConfGet(path, ArraySize) - number of elements<br>ConfGet(path, ReadOnly) - returns 1 if node is read-only, 0 otherwise<br>ConfGet(path, ConfRev) - conf (merge) rev number the value last changed</td><td></td>
<tr><td>Convert</td><td>Convert objects into a polygon or a group.</td><td>Convert(selected|buffer|object|list, poly[gon]|group|sym[bol]|term[inal], [oidlist])</td><td>construct plugin</td>
<tr><td>CreateMenu</td><td>Creates a new menu, popup (only path specified) or submenu (at least path and action are specified)</td><td>CreateMenu(path)<br>CreateMenu(path, action, tooltip, cookie, [accel])</td><td></td>
<tr><td><a href="action_details.html#cursor">Cursor</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Move the cursor.</td><td>Cursor(Type,DeltaUp,DeltaRight,Units)</td><td></td>
<tr><td>d1</td><td>debug action for development</td><td>d1()</td><td>diag plugin</td>
<tr><td>dad</td><td>Manipulate Dynamic Attribute Dialogs</td><td>dad(dlgname, new) - create new dialog<br>dad(dlgname, label, text) - append a label widget<br>dad(dlgname, button, text) - append a button widget<br>dad(dlgname, button_closes, label, retval, ...) - standard close buttons<br>dad(dlgname, enum, choices) - append an enum (combo box) widget; choices is a tab separated list<br>dad(dlgname, bool) - append an checkbox widget (default off)<br>dad(dlgname, integer|real|coord, min, max) - append an input field<br>dad(dlgname, string) - append a single line text input field<br>dad(dlgname, default, val) - set the default value of a widet while creating the dialog<br>dad(dlgname, help, tooltip) - set the help (tooltip) text for the current widget<br>dad(dlgname, progress) - append a progress bar (set to 0)<br>dad(dlgname, preview, cb_act_prefix, minsize_x, minsize_y, [ctx]) - append a preview with a viewbox of 10*10mm, minsize in pixels<br>dad(dlgname, tree, cols, istree, [header]) - append tree-table widget; header is like enum values<br>dad(dlgname, tree_append, row, cells) - append after row (0 means last item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, tree_append_under, row, cells) - append at the end of the list under row (0 means last item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, tree_insert, row, cells) - insert before row (0 means first item of the root); cells is like enum values; returns a row pointer<br>dad(dlgname, begin_hbox) - begin horizontal box<br>dad(dlgname, begin_vbox) - begin vertical box<br>dad(dlgname, begin_hpane) - begin horizontal paned box<br>dad(dlgname, begin_vpane) - begin vertical paned box<br>dad(dlgname, begin_table, cols) - begin table layout box<br>dad(dlgname, begin_tabbed, tabnames) - begin a view with tabs; tabnames are like choices in an enum; must have as many children widgets as many names it has<br>dad(dlgname, end) - end the last begin<br>dad(dlgname, flags, flg1, flg2, ...) - change the flags of the last created widget<br>dad(dlgname, onchange, action) - set the action to be called on widget change<br>dad(dlgname, run, title) - present dlgname as a non-modal dialog<br>dad(dlgname, run_modal, title) - present dlgname as a modal dialog<br>dad(dlgname, exists) - returns wheter the named dialog exists (0 or 1)<br>dad(dlgname, set, widgetID, val) - changes the value of a widget in a running dialog <br>dad(dlgname, get, widgetID, [unit]) - return the current value of a widget<br>dad(dlgname, iterate) - runs a global GUI iteration (event dispatch, redraw)<br>dad(dlgname, raise) - pops up window in front<br>dad(dlgname, close) - close the dialog (and return 0 from modal run)</td><td>lib_hid_common plugin</td>
<tr><td>DevmaplibCleanLocal</td><td>Remove all local-lib devmaps from the current sheet; they are re-loaded from external libs into the local lib upon the next compilation. Useful to refresh local lib from disk.</td><td>DevmaplibCleanLocal()</td><td>devmap</td>
<tr><td>DevmaplibRehash</td><td>Rebuild the in-memory tree of devmaps</td><td>DevmaplibRehash()</td><td>devmap</td>
<tr><td>DiscardAbstract</td><td>Free the abstract model of the current project.</td><td>CompileProject()</td><td>project_act</td>
<tr><td>dlg_confval_edit</td><td>Present a dialog box for editing the value of a conf node at path.</td><td>dlg_confval_edit(path, idx, role, [modal])</td><td>lib_hid_common plugin</td>
<tr><td>DrawArc</td><td>Draw an arc. Angles are in degrees.</td><td>DrawArc([noundo], [retptr], scope, cx, cy, r, start_ang, delta_ang, [pen])</td><td>draw plugin</td>
<tr><td>DrawCircle</td><td>Draw a 360 degree arc (full circle).</td><td>DrawCircle([noundo], [retptr], scope, cx, cy, r, [pen])</td><td>draw plugin</td>
<tr><td>DrawGroup</td><td>Create a new concrete group. Optionally create key=value string attributes in the new group.</td><td>DrawGroup([noundo], [retptr], scope, [key, value], [key, value]...)</td><td>draw plugin</td>
<tr><td>DrawLine</td><td>Draw a decoration line.</td><td>DrawLine([noundo], [retptr], scope, x1, y1, x2, y2, [pen])</td><td>draw plugin</td>
<tr><td>DrawRelease</td><td>Release the pointer of an object. Call this after Draw*(retptr,...) when the object is no longer needed. Unreleased objects are leaked. Warning: there is NO reference counting; getting the same object twice will get only one registration, then releasing "one of them" will release both! NEVER keep pointers across invocations.</td><td>DrawRelease(objptr)</td><td>draw plugin</td>
<tr><td>DrawText</td><td>Create a non-bbox-specified text object.</td><td>DrawText([noundo], [retptr], scope, x, y, text, [pen])</td><td>draw plugin</td>
<tr><td>DrawWire</td><td>Draw a wire on the sheet of scope. Draws junctions and makes connections and merges nets as needed.</td><td>DrawWire([noundo], [retptr], scope, x1, y1, x2, y2, [pen])</td><td>draw plugin</td>
<tr><td>DRC</td><td>Invoke the DRC check. Results are presented as the argument requests.</td><td>DRC([list|print|log])</td><td>libcschem/drc</td>
<tr><td>duktape</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>DumpActions</td><td>Dump all actions available.</td><td>DumpActions()</td><td></td>
<tr><td>dumpconf</td><td>Perform various operations on the configuration tree.</td><td>dumpconf(native, [verbose], [prefix]) - dump the native (binary) config tree to stdout<br>dumpconf(lihata, role, [prefix]) - dump in-memory lihata representation of a config tree</td><td>diag_rnd</td>
<tr><td>DumpPluginDirs</td><td>Print plugins directories in a format digestable by scripts.</td><td>DumpPluginDirs()</td><td></td>
<tr><td>DumpPlugins</td><td>Print plugins loaded in a format digestable by scripts.</td><td>DumpPlugins()</td><td></td>
<tr><td>DumpVersion</td><td>Dump version in script readable format.</td><td>DumpVersion()</td><td></td>
<tr><td>EditText</td><td>Bring up a text quick edit dialog.</td><td>EditText([object[=idpath]])</td><td>sch_dialogs</td>
<tr><td>estutter</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>EvalConf</td><td>Perform various operations on the configuration tree.</td><td>EvalConf(path) - evaluate a config path in different config sources to figure how it ended up in the native database</td><td>diag_rnd</td>
<tr><td>ExecActionFile</td><td>Run actions from the given file.</td><td>ExecActionFile(filename)</td><td></td>
<tr><td>ExecCommand</td><td>Run shell command</td><td>System(shell_cmd)</td><td></td>
<tr><td>Export</td><td>Export the current layout, e.g. Export(png, --dpi, 600)</td><td>Export(exporter, [exporter-args])</td><td></td>
<tr><td>ExportDialog</td><td>Open the export dialog.</td><td>ExportDialog()</td><td>lib_hid_common plugin</td>
<tr><td>ExportProjectDialog</td><td>Open the export dialog for exporting the project (all sheets of the project).</td><td>ExportDialog()</td><td>sch_rnd_gui</td>
<tr><td>fawk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>fbas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>FontFind</td><td>Finds a font by the same name:style combo pens use</td><td>FontFind(name, style)</td><td>diag plugin</td>
<tr><td>FontInfo</td><td>Test-render str and return width or height.</td><td>FontInfo(TextWidth|TextHeight, str, [penname])</td><td></td>
<tr><td>fpas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>FsdSimple</td><td>File selection dialog, simplified API; for meaning of the arguments, see the HID API doc.</td><td>FsdSimple(title, descr, default_file, default_ext, history_tag, [read])</td><td>lib_hid_common plugin</td>
<tr><td>FsdTest</td><td>Central, DAD based File Selection Dialog demo</td><td>FsdTest()</td><td>lib_hid_common plugin</td>
<tr><td>FullScreen</td><td>Hide widgets to get edit area full screen</td><td>FullScreen(on|off|toggle)</td><td></td>
<tr><td><a href="action_details.html#funcmapchange">FuncmapChange</a></td><td>Change the alternate function of a component-port. The setgrp command activates a group by setting all affected ports to that group's funcionality. All arguments are case-sensitive.</td><td>FuncmapChange(previous|next|remove, component, port)<br>FuncmapChange(set, component, port, [newfunc])<br>FuncmapChange(setgrp, component, grpname)</td><td>funcmap</td>
<tr><td>FuncmapComponentDialog</td><td>Open the alternate function mapping dialog for a component</td><td>FuncmapComponentDialog(object)</td><td>funcmap</td>
<tr><td>FuncmaplibCleanLocal</td><td>Remove all local-lib funcmaps from the current sheet; they are re-loaded from external libs into the local lib upon the next compilation. Useful to refresh local lib from disk.</td><td>FuncmaplibCleanLocal()</td><td>funcmap</td>
<tr><td>FuncmaplibRehash</td><td>Rebuild the in-memory tree of funcmaps</td><td>FuncmaplibRehash()</td><td>funcmap</td>
<tr><td>FuncmapPortDialog</td><td>Open the modal dialog for changing the alternate function of a port. </td><td>FuncmapPortDialog(object, component, port)</td><td>funcmap</td>
<tr><td><a href="action_details.html#funcmapprinttable">FuncmapPrintTable</a></td><td>Print a table of all alternative port functions for a component If column is specified, sort the table by the named column.</td><td>FuncmapPrintTable(component, [column])</td><td>funcmap</td>
<tr><td>GetObjType</td><td>Return the type of the object named in oidpath as a string.</td><td>GetObjType([root_data,] idpath)</td><td>act_read</td>
<tr><td>GetParentGrp</td><td>Return the oidpath of the immediate parent group of an object</td><td>GetParentGrp([root_data,] idpath)</td><td>act_read</td>
<tr><td>GetValue</td><td>Convert a coordinate value. Returns an unitless double or FGW_ERR_ARG_CONV. The 3rd parameter controls whether to require relative coordinates (+- prefix). Wraps rnd_get_value_ex().</td><td>GetValue(input, units, relative, default_unit)</td><td>act_read</td>
<tr><td><a href="action_details.html#getxy">GetXY</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Get a coordinate. If x or y specified, the return value of the action is the x or y coordinate.</td><td>GetXY([message, [x|y]])</td><td></td>
<tr><td>Grid</td><td>Set the grid.</td><td>grid(set, [name:]size[@offs][!unit])<br>grid(+|up)<br>grid(-|down)<br>grid(#N)<br>grid(idx, N)<br>grid(get)<br>grid(ask)</td><td></td>
<tr><td>gui_FallbackColorPick</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_MayOverwriteFile</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_MessageBox</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>gui_PromptFor</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>Help</td><td>On-line action help</td><td>Help()</td><td></td>
<tr><td>HlibraryRehash</td><td>Rebuild the in-memory tree of hierarchic sheet libraries</td><td>HlibraryRehash()</td><td></td>
<tr><td>IDP</td><td>Basic idpath manipulation.</td><td>IDP([print|free|dup], idpath)</td><td>act_read</td>
<tr><td>IDPList</td><td>Basic idpath list manipulation.</td><td>IDPList(alloc)<br>IDPList(free|clear|print|dup|length, list)<br>IDPList(get|pop|remove, list, idx)<br>IDPList(prepend|append|push, list, idpath)</td><td>act_read</td>
<tr><td>InfoBarFileChanged</td><td>Present the "file changed" warning info bar with buttons to reload or cancel</td><td>InfoBarFileChanged(open|close)</td><td>sch_dialogs</td>
<tr><td>Integrity</td><td>Run data integrity checks on current sheet.</td><td>Integrity()</td><td>libcschem/integrity.c</td>
<tr><td>irc</td><td>non-modal, single-instance, single-server, single-channel irc window for online support</td><td>irc()</td><td>irc plugin</td>
<tr><td>javascript</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>js</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>LibraryDialog</td><td>Bring up the library dialog. Default lib_type_name is "symbol". "Sheet" is the sheet's local library (one dialog per sheet), "global" is all symbols mapped for any sheet seen in this session. In modal mode returns the tree path of the selected entry.</td><td>LibraryDialog([lib_type_name, [sheet|global, [modal]]])</td><td>sch_dialogs</td>
<tr><td><a href="action_details.html#listscripts">ListScripts</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>List fungw scripts, optionally filtered wiht regex pat.</td><td>ListScripts([pat])</td><td>script plugin</td>
<tr><td><a href="action_details.html#livescript">LiveScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Manage a live script</td><td>LiveScript([new], [name])<br>LiveScript(load|save, name, [filame])<br>LiveScript(run|stop|rerun|undo, name)</td><td>script plugin</td>
<tr><td>Load</td><td>Load a project or a schematics sheet from a user-selected file.</td><td>Load()<br>Load(Project|Sheet)</td><td>sch_rnd_gui</td>
<tr><td>LoadFrom</td><td>Load project or sheet data from a file.</td><td>LoadFrom(Sheet|Project,filename[,format])</td><td>plug_io_act</td>
<tr><td><a href="action_details.html#loadscript">LoadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Load a fungw script</td><td>LoadScript(id, filename, [language])</td><td>script plugin</td>
<tr><td>Log</td><td>Manages the central, in-memory log.</td><td>Log(clear, [fromID, [toID])<br>Log(export, [filename, [text|lihata])</td><td></td>
<tr><td>LogDialog</td><td>Open the log dialog.</td><td>LogDialog()</td><td>lib_hid_common plugin</td>
<tr><td>LogGui</td><td>Log() action GUI section</td><td>LogGui(export, [filename, [text|lihata])</td><td></td>
<tr><td>lua</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>ManagePlugins</td><td>Manage plugins dialog.</td><td>ManagePlugins()</td><td>lib_hid_common plugin</td>
<tr><td>mawk</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>MenuDebug</td><td>Menu debug helpers: save the merged menu in a file</td><td>MenuDebug(save, path)</td><td></td>
<tr><td>MenuPatch</td><td>Manage menu patches</td><td>MenuPatch(load, cookie, path, desc)<br>MenuPatch(unload, cookie)<br>MenuPatch(list)<br>MenuPatch(InhibitInc|InhibitDec)</td><td></td>
<tr><td><a href="action_details.html#message">Message</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Writes a message to the log window.</td><td>message([ERROR|WARNING|INFO|DEBUG,] message)</td><td></td>
<tr><td>MessageBox</td><td>Open a modal message dialog box with title and label. If icon string is not empty, display the named icon on the left. Present one or more window close buttons with different text and return value.</td><td>MessageBox(icon, title, label, button_txt, button_retval, ...)</td><td></td>
<tr><td>Mirror</td><td>Mirror object or buffer. Default target is auto. Default direction is horizontal.</td><td>Mirror([object|buffer|auto], [horizontal|vertical])</td><td>sch_rnd_gui</td>
<tr><td>Mode</td><td>Change or use the tool mode.</td><td>Tool(Arc|Arrow|Copy|InsertPoint|Line|Lock|Move|None|PasteBuffer)<br>Tool(Poly|Rectangle|Remove|Rotate|Text|Thermal|Via)<br>Tool(Press|Release|Cancel|Stroke)<br>Tool(Save|Restore)</td><td></td>
<tr><td>MoveCursorTo</td><td>Move the cursor to absolute coords, pan the view as needed.</td><td>MoveCursorTo(x,y)</td><td></td>
<tr><td>mruby</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>New</td><td>Create a new sheet. Scope is a project path or @ for current project.</td><td>New([scope, [root|aux|unlisted]])</td><td></td>
<tr><td>Oneliner</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td><a href="action_details.html#pan">Pan</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Start or stop panning (Mode = 1 to start, 0 to stop)</td><td>Pan(Mode)</td><td>lib_hid_common plugin</td>
<tr><td>pas</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>pcb_acos</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_asin</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_atan2</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_atan</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_cos</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_rand</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_sin</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_sqrt</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_srand</td><td></td><td></td><td>script plugin</td>
<tr><td>pcb_tan</td><td></td><td></td><td>script plugin</td>
<tr><td>PenDialog</td><td>Bring up a modal pen selecton dialog. If idpath is specified, list pens starting from the group addressed by idpath. If second argument is non-modal, the dialog is not modal; else it is modal and the user selected pen is returned (as idpath). If recursive is set, map pens of parents as well. If ret_name is set, return the name of the selected pen (or NULL on no selection) instead of the usual integer return. If init_pen_name is supplied, the cursor is set to that pen.</td><td>PenDialog([object[=idpath]], [non-modal], [recursive], [ret_name], [init_pen_name])</td><td>sch_dialogs</td>
<tr><td>perl</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>PlaceAttrib</td><td>Place an attribute floater dyntext</td><td>PlaceAttrib([sheet|buffer])</td><td>place plugin</td>
<tr><td>PlaceTerminal</td><td>Place a terminal group template </td><td>PlaceTerminal([sheet|buffer])</td><td>place plugin</td>
<tr><td>PlotTest</td><td>Open the plot test dialog</td><td>PlotTest()</td><td>sim_gui</td>
<tr><td>Popup</td><td>Bring up the popup menu specified by MenuName, optionally modified with the object type under the cursor.</td><td>Popup(MenuName, [obj-type])</td><td>sch_rnd_gui</td>
<tr><td>Preferences</td><td>Present the preferences dialog, optionally opening the tab requested.</td><td>Preferences([tabname])</td><td>lib_hid_common plugin</td>
<tr><td><a href="action_details.html#print">Print</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Present the print export dialog for printing the layout from the GUI.</td><td>Print()</td><td></td>
<tr><td>PrintActions</td><td>Print all actions available.</td><td>PrintActions()</td><td></td>
<tr><td>PrintCopyright</td><td>Print copyright notice.</td><td>PrintCopyright()</td><td></td>
<tr><td>PrintDialog</td><td>Open the print dialog.</td><td>PrintDialog()</td><td>lib_hid_common plugin</td>
<tr><td>PrintFiles</td><td>Print files currently loaded.</td><td>PrintFiles()</td><td></td>
<tr><td>PrintGUI</td><td>Open the print dialog.</td><td>PrintDialog()</td><td>sch_dialogs</td>
<tr><td>PrintPaths</td><td>Print full paths and search paths.</td><td>PrintPaths()</td><td></td>
<tr><td>PrintUsage</td><td>Print command line arguments of sch-rnd or a plugin loaded.</td><td>PrintUsage()<br>PrintUsage(plugin)</td><td></td>
<tr><td>PrintVersion</td><td>Print version.</td><td>PrintVersion()</td><td></td>
<tr><td>ProjectDialog</td><td>Bring up a modal project edit dialog for editing file listings of a project.</td><td>ProjectDialog()</td><td>sch_dialogs</td>
<tr><td>ProjectLoadPartial</td><td>Load sheet's missing files (or in other words, load the project file of the sheet)</td><td>ProjectLoadPartial([@])</td><td></td>
<tr><td>ProjectNew</td><td>Create a new project</td><td>ProjectNew([path])</td><td></td>
<tr><td>ProjectSheetType</td><td>Change the type of a sheet (addressed by its full path) in a project, making the necessary modifications in the project file</td><td>ProjectSheetType(@, sheet_fullpath, root|aux|unlisted|unload)</td><td></td>
<tr><td><a href="action_details.html#promptfor">PromptFor</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Prompt for a string. Returns the string (or NULL on cancel)</td><td>PromptFor([message[,default[,title]]])</td><td></td>
<tr><td>propedit</td><td></td><td>propedit(object[:id]|sheet|selection)</td><td>propedit</td>
<tr><td>propget</td><td>Return the named property of scope or all selected objects to/by value. Scope is documented at PropEdit().</td><td>propget([scope], name, [stattype])</td><td>propedit</td>
<tr><td>propprint</td><td>Print a property map of objects matching the scope. Scope is documented at PropEdit().</td><td>PropPrint([scope])</td><td>propedit</td>
<tr><td>propset</td><td>Change the named property of scope or all selected objects to/by value. Scope is documented at PropEdit(). Existing attributes can be renamed to value by using a name rename/a/old_name, where old_name is the current name of the attribute.</td><td>propset([scope], name, value)</td><td>propedit</td>
<tr><td>proptoggle</td><td>Toggle the named property of scope or all selected objects, assuming the property is boolean. Scope is documented at PropEdit(). If create is true, non-existing attributes are created as true.</td><td>proptoggle([scope], name, [create])</td><td>propedit</td>
<tr><td>py</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>python</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>query</td><td>Perform various queries on concrete model data.</td><td>query(dump, expr) - dry run: compile and dump an expression<br>query(eval|evalidp, expr) - compile and evaluate an expression and print a list of results on stdout<br>query(count, expr) - compile and evaluate an expression and return the number of matched objects (-1 on error)<br>query(select|unselect|view, expr) - select or unselect or build a view of objects matching an expression<br>query(append, idplist, expr) - compile and run expr and append the idpath of resulting objects on idplist</td><td>query plugin</td>
<tr><td>QueryCompileField</td><td>With "compile": precompiles textual field name to field ID; with "free": frees the memory allocated for a previously precompiled fieldID.</td><td>QueryCompileField(compile, fieldname)<br>QueryCompileField(free, fieldID)</td><td>query plugin</td>
<tr><td>QueryObj</td><td>Return the value of a field of an object, addressed by the object's idpath and the field's name or precompiled ID. Returns NIL on error.</td><td>QueryObj(idpath, [.fieldname|fieldID])</td><td>query plugin</td>
<tr><td>QuickAttr</td><td>Quick Attribute Edit on key</td><td>QuickAttr(last-click|parent|object[:idpath], key)</td><td>sch_dialogs</td>
<tr><td>QuickAttrEditable</td><td>Returns 1 if obj:key has a quick attribute edit</td><td>QuickAttrEditable(last-click|parent|object[:idpath], key)</td><td>sch_dialogs</td>
<tr><td>quick_attr_connect</td><td>Quick Attribute Edit for core data model's symbol connect attribute (attribute based symbol terminal to network connection table)</td><td>quick_attr_connect(objptr)</td><td>std_cschem</td>
<tr><td>quick_attr_devmap</td><td>Quick Attribute Edit for devmap using the devmap library</td><td>quick_attr_devmap(objptr)</td><td>devmap</td>
<tr><td>quick_attr_forge__if__dnp</td><td>Quick Attribute Edit for the standard forge-if/dnp attribute</td><td>quick_attr_forge__if__dnp(objptr)</td><td>sch_dialogs</td>
<tr><td>quick_attr_forge__if__omit</td><td>Quick Attribute Edit for the standard forge-if/omit attribute</td><td>quick_attr_forge__if__dnp(objptr)</td><td>sch_dialogs</td>
<tr><td>quick_attr_forge__if__test_bench</td><td>Quick Attribute Edit for core data model's symbol connect attribute (attribute based symbol terminal to network connection table)</td><td>quick_attr_forge__if__test_bench(objptr)</td><td>std_forge</td>
<tr><td>quick_attr_funcmap</td><td>Quick Attribute Edit for funcmap using the funcmap library</td><td>quick_attr_funcmap(objptr)</td><td>funcmap</td>
<tr><td>quick_attr_portmap</td><td>Quick Attribute Edit for core data model's symbol portmap attribute (attribute based "symbol terminal to network" portmap table)</td><td>quick_attr_portmap(objptr)</td><td>devmap</td>
<tr><td>quick_attr_role</td><td>Quick Attribute Edit for core data model's role attribute</td><td>quick_attr_role(objptr)</td><td>sch_dialogs</td>
<tr><td>quick_attr_spice__model</td><td>Quick Attribute Edit for spice/model using the devmap library</td><td>quick_attr_spice__model(objptr)</td><td>target_spice/spicelib</td>
<tr><td><a href="action_details.html#quit">Quit</a></td><td>Quits sch-rnd after confirming.</td><td>Quit()</td><td></td>
<tr><td>Redo</td><td>Redo recent "undo" operations.</td><td>redo()</td><td>libcschem/undo.c</td>
<tr><td>Redraw</td><td>Redraw the entire screen</td><td>Redraw()</td><td></td>
<tr><td><a href="action_details.html#reloadscript">ReloadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Reload a fungw script</td><td>ReloadScript(id)</td><td>script plugin</td>
<tr><td>RemoveMenu</td><td>Recursively removes a new menu, popup (only path specified) or submenu. </td><td>RemoveMenu(path, cookie)</td><td></td>
<tr><td>RemoveSelected</td><td>Remove all selected objects</td><td>RemoveSelected()</td><td></td>
<tr><td>Renumber</td><td>Rename (renumber) selected or all symbols on current sheet or on all sheets of the project. Second argument is the direction of numbering (e.g. rl means right-to-left). If base is specified, it is an integer and is the first number assigned. Non-numerical name prefix is preserved (R, C, etc.)</td><td>Renumber(Selected|All|SelectedProject|AllProject, lr|rl|tb|bt, [base])</td><td>renumber</td>
<tr><td>RenumberDialog</td><td>Open the graphical frontend dialog box for the Renumber() action. The dialog box is single instance and non-modal.</td><td>RenumberDialog()</td><td>renumber</td>
<tr><td>ReplaceSymbol</td><td>Replace target symbol with the first symbol from the buffer</td><td>ReplaceSymbol([object])</td><td></td>
<tr><td>Revert</td><td>Revert to on-disk version of file(s). Default target is sheet.</td><td>Revert([sheet|project])</td><td></td>
<tr><td>rnd_acos</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_asin</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_atan2</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_atan</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_cos</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_dlg_xpm_by_name</td><td>Intenal: GUI frontend action. Do not use directly.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_rand</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_sin</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_sqrt</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_srand</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_tan</td><td></td><td></td><td>script plugin</td>
<tr><td>rnd_toolbar_init</td><td>For ringdove apps: initialize the toolbar.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_toolbar_uninit</td><td>For ringdove apps: uninitialize the toolbar.</td><td></td><td>lib_hid_common plugin</td>
<tr><td>rnd_zoom</td><td>Change zoom level (relative, absolute, window, ...)</td><td>Zoom()<br>Zoom([+|-|=]factor)<br>Zoom(x1, y1, x2, y2)<br>Zoom(?)<br>Zoom(get)</td><td>lib_hid_common plugin</td>
<tr><td>Rotate90</td><td>Rotate object or buffer CCW in 90 degree steps. Default target is auto. Default steps is 1.</td><td>Rotate90([object|buffer|auto], [steps])<br>Rotate90(idpath, steps, idp, x, y)</td><td>sch_rnd_gui</td>
<tr><td>Rotate</td><td>Rotate object or buffer CCW in def degrees. Default target is auto. Default deg is ask (which prompts for a value).</td><td>Rotate([object|buffer|auto], [deg|ask])</td><td>sch_rnd_gui</td>
<tr><td><a href="action_details.html#rtreelist">RtreeList</a></td><td>Return a list of idpaths for objects overlapping with the box specified (empty list if no object is found). Error is indicated by returning nil. If coordinates are not specified the whole tree is searched.</td><td>RtreeList[rtree_name, [x1, y1, x2, y2])</td><td>act_read</td>
<tr><td>ruby</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>SafeFsclearerr</td><td>Same as clearerr(3)</td><td>SafeFsclearerr(f)</td><td></td>
<tr><td>SafeFsFclose</td><td>Closes a file previously open using SafeFsFopen()</td><td>SafeFsFclose(f)</td><td></td>
<tr><td>SafeFsFeof</td><td>Returns 1 if file has reached EOF, 0 otherwise</td><td>SafeFsFeof(f)</td><td></td>
<tr><td>SafeFsFerror</td><td>Returns 1 if file had errors, 0 otherwise</td><td>SafeFsFerror(f)</td><td></td>
<tr><td>SafeFsFgets</td><td>Reads and returns a line from f (open with SafeFsFopen()). Stops reading after maxlen (subsequent call will continue reading the same line). Returns nil on error or eof or empty line. Maxlen is 64k by default. Note: string heap allocation is made for maxlen.</td><td>SafeFsFgets(f, [maxlen])</td><td></td>
<tr><td>SafeFsFileMtime</td><td>Return the last modification time of a file, from Epoch, or -1 on error.</td><td>SafeFsFileMtime(path)</td><td></td>
<tr><td>SafeFsFileSize</td><td>Return the size of a file in bytes, or -1 on error.</td><td>SafeFsFileSize(path)</td><td></td>
<tr><td>SafeFsFopen</td><td>Opens a file using fopen, returns FILE *. If mode is not specified, r is assumed. Returns nil on error.</td><td>SafeFsFopen(path, [mode])</td><td></td>
<tr><td>SafeFsFputs</td><td>Writes str to file f (previously opne with SafeFsFopen))</td><td>SafeFsFputs(f, str)</td><td></td>
<tr><td>SafeFsFread</td><td>Reads and returns at most len bytes from a file (open with SafeFsFopen()). Returns nil on error or eof or empty line.</td><td>SafeFsFread(f, len)</td><td></td>
<tr><td>SafeFsFreadSep</td><td>Reads characters that are either all non-seps or all seps. Reads at most maxlen bytes. Returns the string read or nil on eof or error. Seps is a string that contains every separator character. Maxlen is 64k by default.</td><td>SafeFsFreadSep(f, seps, [maxlen])</td><td></td>
<tr><td>SafeFsFseek</td><td>Same as fseek(3); whence is a string, one of set, cur or end not specified (set is used when not specified)</td><td>SafeFsFseek(f, offs, [whence])</td><td></td>
<tr><td>SafeFsFtell</td><td>Same as ftell(3).</td><td>SafeFsFtell(f)</td><td></td>
<tr><td>SafeFsIsDir</td><td>Return 1 if path exists and is a directory, else return 0.</td><td>SafeFsIsDir(path)</td><td></td>
<tr><td>SafeFsMkdir</td><td>Mkdir a file from the file system. If mode is a string, it is converted from octal. Return value is the same as mkdir(2)'s</td><td>SafeFsMkdir(path, mode)</td><td></td>
<tr><td>SafeFsPathSep</td><td>Return the system dependet path separator character (normally slash).</td><td>SafeFsPathSep(path)</td><td></td>
<tr><td>SafeFsReadFile</td><td>Reads a text file into one long string, returned, but at most maxlen bytes. If maxlen is not specified, 64k is used. Returns nil on error or empty file.</td><td>SafeFsReadFile(path, [maxlen])</td><td></td>
<tr><td>SafeFsRealPath</td><td>Returns the realpath(3) of path, or NULL on error.</td><td>SafeFsRealPath(path)</td><td></td>
<tr><td>SafeFsRemove</td><td>Remove an object from the file system. Return value is the same as remove(3)'s</td><td>SafeFsRemove(path)</td><td></td>
<tr><td>SafeFsRename</td><td>Rename an object on the file system. Return value is the same as rename(2)'s</td><td>SafeFsRename(old_path, new_path)</td><td></td>
<tr><td>SafeFsRewind</td><td>Same as rewind(3)</td><td>SafeFsRewind(f)</td><td></td>
<tr><td>SafeFsSystem</td><td>Runs cmdline with a shell using librnd safe_fs. Return value is the same integer as system()'s</td><td>SafeFsSystem(cmdline)</td><td></td>
<tr><td>SafeFsUnlink</td><td>Unlink a file from the file system. Return value is the same as unlink(2)'s</td><td>SafeFsUnlink(path)</td><td></td>
<tr><td>Save</td><td>Save a project or a schmeatics sheet trying to preserve original file name.</td><td>Save()<br>Save(Project|Sheet)</td><td>sch_rnd_gui</td>
<tr><td>SaveAll</td><td>Save all unsaved sheets in current project (currprj)</td><td>SaveAll([currprj])</td><td></td>
<tr><td>SaveAs</td><td>Save a project or a schmeatics sheet using a new file name.</td><td>SaveAs(Project|Sheet, [filename])</td><td>sch_rnd_gui</td>
<tr><td>SaveTo</td><td>Save project or sheet to a file.</td><td>SaveTo(Sheet|Project,filename[,format])</td><td>plug_io_act</td>
<tr><td>SchGetXY</td><td>Return the cursor (or crosshair) x or y coord. Msg is a string displayed when cursor coord is requested but cursor is not active (see GetXY()).</td><td>SchGetXY(cursor|crosshair, msg, X|Y)</td><td>act_read</td>
<tr><td><a href="action_details.html#scriptcookie">ScriptCookie</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Return a cookie specific to the current script instance during script initialization</td><td>ScriptCookie()</td><td>script plugin</td>
<tr><td><a href="action_details.html#scriptpersistency">ScriptPersistency</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Read or remove script persistency data savd on preunload</td><td>ScriptPersistency(read|remove)</td><td>script plugin</td>
<tr><td><a href="action_details.html#scroll">Scroll</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Scroll the viewport.</td><td>Scroll(up|down|left|right, [pixels])</td><td>lib_hid_common plugin</td>
<tr><td>SearchDialog</td><td>Open the log dialog.</td><td>SearchDialog()</td><td>query plugin</td>
<tr><td>SearchObjAt</td><td>Return the most preferred object at mouse cursor (or crosshair) or x;y coord; search in a raduis of r coords. The unsel variant ignores selected objects. The GuiInspect variant uses the priorities right-click does. Msg is a string displayed when cursor coord is requested but cursor is not active (see GetXY()). Returns nil or an idpath.</td><td>SearchObjAt[UnSel|GuiInspect](cursor|crosshair, msg, [r])<br>SearchObjAt[UnSel|GuiInspect](x, y, [r])</td><td>act_read</td>
<tr><td>SearchObjAtGuiInspect</td><td>Return the most preferred object at mouse cursor (or crosshair) or x;y coord; search in a raduis of r coords. The unsel variant ignores selected objects. The GuiInspect variant uses the priorities right-click does. Msg is a string displayed when cursor coord is requested but cursor is not active (see GetXY()). Returns nil or an idpath.</td><td>SearchObjAt[UnSel|GuiInspect](cursor|crosshair, msg, [r])<br>SearchObjAt[UnSel|GuiInspect](x, y, [r])</td><td>act_read</td>
<tr><td>SearchObjAtUnsel</td><td>Return the most preferred object at mouse cursor (or crosshair) or x;y coord; search in a raduis of r coords. The unsel variant ignores selected objects. The GuiInspect variant uses the priorities right-click does. Msg is a string displayed when cursor coord is requested but cursor is not active (see GetXY()). Returns nil or an idpath.</td><td>SearchObjAt[UnSel|GuiInspect](cursor|crosshair, msg, [r])<br>SearchObjAt[UnSel|GuiInspect](x, y, [r])</td><td>act_read</td>
<tr><td>Select</td><td>Select objects; all=all visible; invert=invert selection; default is all.</td><td>Select([All|Invert])</td><td></td>
<tr><td>SetGrid</td><td>Change grid size.</td><td>SetGrid(delta|*mult|/div, [unit])</td><td></td>
<tr><td><a href="action_details.html#setgridoffs">SetGridOffs</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Change grid offset (alignment) to x_offs and y_offs. Offsets should be specified with units.</td><td>SetGridOffs(x_offs, y_offs)</td><td></td>
<tr><td><a href="action_details.html#setunits">SetUnits</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Set the default measurement units.</td><td>SetUnits(mm|mil)</td><td></td>
<tr><td>SimActivate</td><td>Activate the simulation for the setup_name+veiw_name combo; setup_name is the name of the sim setup to use, view name is the name of a view that has a suitable sim target. Triggers timed autocompile.</td><td>SimActivate(setup_name, view_name)</td><td>sim</td>
<tr><td>SimDialog</td><td>Open the sim(ulation) dialog</td><td>SimDlg()</td><td>sim_gui</td>
<tr><td>SimDlg</td><td>Open the sim(ulation) dialog</td><td>SimDlg()</td><td>sim_gui</td>
<tr><td>SimRun</td><td>Activate and run the simulation, see SimActivate()</td><td>SimRun(setup_name, view_name, [output_filename])</td><td>sim</td>
<tr><td>SimSetupDialog</td><td>Open the sim(ulation) setup/run dialog for the named setup in the current project</td><td>SimDlg(setup_name)</td><td>sim_gui</td>
<tr><td>SimSetupDlg</td><td>Open the sim(ulation) setup/run dialog for the named setup in the current project</td><td>SimDlg(setup_name)</td><td>sim_gui</td>
<tr><td>StanceDialog</td><td>Open the current project's stance configuration dialog.</td><td>StanceDialog()</td><td>sch_dialogs</td>
<tr><td>StatusSetText</td><td>Replace status printout with text temporarily; turn status printout back on if text is not provided.</td><td>StatusSetText([text])</td><td>sch_rnd_gui</td>
<tr><td>stroke</td><td>Various gesture recognition related functions</td><td>stroke(gesture, seq)</td><td>stroke plugin</td>
<tr><td>stt</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>SwitchRelative</td><td>Switch to a different sheet by traversing integer steps on the linked list of sheets loaded</td><td>SwitchRelative(steps)</td><td>sch_rnd_gui</td>
<tr><td>SymlibRehash</td><td>Rebuild the in-memory tree of symbol libraries</td><td>SymlibRehash()</td><td></td>
<tr><td>SymlibReloadAllLocal</td><td>Replace all local symbols from a newer version of the same symbol from the symbol library</td><td>SymlibReloadAllLocal()</td><td></td>
<tr><td>SymLocLib</td><td>Convert between "embedded" symbols (full copy) and local lib symbol references</td><td>SymLocLib(object[:idpath]|selected, [toref|togrp])</td><td>symlib_local</td>
<tr><td>System</td><td>Run shell command</td><td>System(shell_cmd)</td><td></td>
<tr><td>tcl</td><td>Execute a script one-liner using a specific language</td><td>Oneliner(lang, script)</td><td>script plugin</td>
<tr><td>TestBenchDialog</td><td>Open the test bench selector for the current object or for selected objects.</td><td>TestBenchDialog(object[:oidpath]|selected)</td><td>std_forge</td>
<tr><td>TestBenchModify</td><td>Modify test bench affiliation of object(s), adding or deleting test benches in which the given objects are participating.</td><td>TestBenchModify(object[:oidpath]|selected, add|del, testbench_name)</td><td>std_forge</td>
<tr><td>ToggleFloaters</td><td>Toggle the setting for only-floaters ot lock-floaters</td><td>ToggleFloaters(only|lock)</td><td></td>
<tr><td><a href="action_details.html#tool">Tool</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Change or use the tool mode.</td><td>Tool(Arc|Arrow|Copy|InsertPoint|Line|Lock|Move|None|PasteBuffer)<br>Tool(Poly|Rectangle|Remove|Rotate|Text|Thermal|Via)<br>Tool(Press|Release|Cancel|Stroke)<br>Tool(Save|Restore)</td><td></td>
<tr><td>TreeDialog</td><td>Bring up the sheet's object tree dialog. If object is specified, move cursor to that object in the tree.</td><td>TreeDialog([object[=idpath]|objarr,vtp0ptr])</td><td>sch_dialogs</td>
<tr><td>Undo</td><td>Undo recent changes.</td><td>undo()<br>undo(ClearList|FreezeSerial|UnfreezeSerial|FreezeAdd|UnfreezeAdd|IncSerial|GetSerial|Above)</td><td>libcschem/undo.c</td>
<tr><td>UndoDialog</td><td>Open the undo dialog.</td><td>UndoDialog()</td><td>sch_dialogs</td>
<tr><td>UndoSplit</td><td>Renumber undo serials so they can be undone separately</td><td>UndoSplit()</td><td>diag plugin</td>
<tr><td>Unload</td><td>Unload (close) current project or sheet</td><td>Unload(Sheet|Project)</td><td>plug_io_act</td>
<tr><td><a href="action_details.html#unloadscript">UnloadScript</a> <sup><a href="#ringdove">(RND)</a></sup></td><td>Unload a fungw script</td><td>UnloadScript(id)</td><td>script plugin</td>
<tr><td>UnSelect</td><td>Unselect all objects. When first argument is omitted or is All, the action operates on the current sheet. When the first argument is AllProject, it operates on all sheets of the current project.</td><td>UnSelect([All|AllProject])</td><td></td>
<tr><td>ViewDialog</td><td>Bring up a modal dialog for selecting the current view or editing views of the current project.</td><td>ViewDialog()</td><td>sch_dialogs</td>
<tr><td><a href="action_details.html#zoom">Zoom</a></td><td>GUI zoom</td><td>Zoom()<br>Zoom([+|-|=]factor)<br>Zoom(x1, y1, x2, y2)<br>Zoom(?)<br>Zoom(get)<br>Zoom(selected)</td><td>sch_rnd_gui</td>
<tr><td>ZoomTo</td><td>GUI zoom</td><td>Zoom()<br>Zoom([+|-|=]factor)<br>Zoom(x1, y1, x2, y2)<br>Zoom(?)<br>Zoom(get)<br>Zoom(selected)</td><td>sch_rnd_gui</td>
</table>
<p id="ringdove">RND: this action comes from librnd and is common to all ringdove applications.
</body>
</html>
